Attribute VB_Name = "Verteilerlisten"

Public Sub VerteilerlistenMenue()
  Dim exFenster As Outlook.Explorer
  Dim menueListen As Office.CommandBar
  Dim btnListen As Office.CommandBarButton
  
  Set exFenster = Application.ActiveExplorer 'das Anwendungsfenster
  Set menueListen = exFenster.CommandBars.Item("Erweitert") 'die Erweitert-Men-Leiste

  Set btnListen = menueListen.Controls.Add(, , , , True) 'dem Men einen Button hinzufgen
  With btnListen
    .Caption = "Verteilerlisten" 'Beschriftung des Button
    .BeginGroup = True 'zur Gestaltung des Mens vor den Button eine Trennlinie
    .DescriptionText = "Exportiert alle Kategorien mit den enthaltenen Kontakten in gleichnamige Verteilerlisten"
    .Visible = True
    .OnAction = "Listen" 'ruft beim Klicken die Subroutine "Listen" auf
  End With
  

End Sub

Private Sub Listen()

Dim NameSpace As NameSpace
Dim objKategorie As Object
Dim colKategorien As New Collection
Dim strFilterKategorien As String
Dim strFilterListen As String
Dim folKontakte As Outlook.Folder
Dim dlVerteilerliste As Outlook.DistListItem
Dim rcEmpfaenger As Outlook.Recipient
Dim itsKontakte As Outlook.Items
Dim itsKontakteAlle As Outlook.Items
Dim itsListen As Outlook.Items
Dim itsZuLoeschen As Outlook.Items
Dim bolErfolg As Boolean
Dim objMail As MailItem

'Arbeitsbereich vorbereiten
Set NameSpace = Application.GetNamespace("MAPI")
Set folKontakte = NameSpace.GetDefaultFolder(olFolderContacts)

'alle vorhandenen Kategorien auslesen und in eine Sammlung einfgen
For Each objKategorie In NameSpace.Categories
    colKategorien.Add (objKategorie.Name) 'die Collection "Kategorien" mit den Namen aller Kategorien fllen
Next
'es handelt sich hierbei um die Kategorien, die in der Liste unter "Alle KAtegorien" bzw. Farbkategorien aufgefhrt wird.
'das bedeutet in diesem Zusammenhang, das Elemente mit Eintrgen im Feld Kategorie, die aber nicht mehr in der Hauptliste vorkommen,
'von diesem Script nicht abgehandelt werden. Auch Verteilerlisten, die anders heien als die Kategorien in der Hauptliste werden nicht angerhrt,
'es bleibt also weiterhin mglich von Hand Verteilerlisten anzulegen, sofern diese nicht heien, wie vorhandene Katgorien...

CollectionSort colKategorien 'die Sammlung der Kategorienamen alphabetisch sortiern - macht sich spter im Handling besser ...

'nun Schleife durch alle Kategorien
For i = 1 To colKategorien.Count
 
    'Suchkriterien, um in den Kontakten die zu finden, die zu einer bestimmten Kategorie gehren
    strFilterKategorien = "@SQL=" & Chr(34) _
    & "urn:schemas-microsoft-com:office:office#Keywords" & Chr(34) _
    & " Like '" & colKategorien(i) & "%'"
    'Der Ausdruck ist deshalb so kompliziert, da da Kategorienfeld aus vielen Eintrgen bestehen kann, die durch Semikolons getrennt sind ...
    
    'Bei der Suche nach einer bestimmten Verteilerliste per Namen ist es einfacher...
    'Suche nach Verteilerlisten (Messageclass=IPM.DistList), die genauso heien, wie die aktuelle Kategorie
    strFilterListen = "[FullName] = ' _" & colKategorien(i) & "_' AND [MessageClass]='IPM.DistList'"

    'Sofern es bereits eine Verteilerliste mit dem Namen der aktuellen Kategorie gibt, soll die zunchst gelscht werden
    Set itsZuLoeschen = folKontakte.Items.Restrict(strFilterListen) 'Suchen, ob es schon eine gibt
    For h = itsZuLoeschen.Count To 1 Step -1               'eigentlich sollte es nur eine geben knnen - aber man wei ja nie ...
        itsZuLoeschen.Remove (h)                           'entfernen der Liste aus der KontakteAuflistung
        'da itsZuLoeschen letztlich eine Referenz auf den KontakteOrdner ist, wird die Liste nicht nur aus itsZuLoeschen entfernt...
    Next
    'Vielleicht ist es wem aufgefallen - vor den Namen der Kategroien/Verteilerlisten steht immer ein Unterstrich und hinten ebenfalls -
    'dazu unten mehr!
        
    
    'Nun kann die Liste neu aufgebaut werden - dazu alle Kontakte suchen, die zu aktuellen Kategorie gehren
    Set itsKontakte = folKontakte.Items.Restrict(strFilterKategorien)
    If itsKontakte.Count > 0 Then 'wenn es welche gibt, eine neue Verteilerliste erstellen
        Set dlVerteilerliste = CreateItem(olDistributionListItem)
        'die Liste erhlt den Namen der aktuellen Kategorie und ein Zeichen, sodass der Name eindeutig wird - eindeutig ist wichtig fr die Resolve-Methode
        dlVerteilerliste.DLName = "_" & colKategorien(i) & " _"
        'die Unterstriche haben aber einen weiteren Grund - dazu unten wie gesagt mehr ...
            
        'Schleife durch die zur Kategroie gehrigen Kontakte
        For j = 1 To itsKontakte.Count
            'Schauen, ob zu den Kontakten auch eine Mailadresse gehrt
            '(ich nutze nur die ersten beiden Mailfelder - ggf. diese Schleife an weitere Mailfelder anpassen)
            If itsKontakte(j).Email1Address <> "" Or itsKontakte(j).Email2Address <> "" Then
                bolErfolg = True 'brauche ich weiter unten ...
                'nun aus der Mailadresse einen "Recipient", also einen Empfnger machen ...
                Set rcEmpfaenger = Outlook.Session.CreateRecipient(itsKontakte(j).Email1Address)
                If rcEmpfaenger.Resolve = True Then 'wird bentigt, um die Adresse "aufzulsen"
                    dlVerteilerliste.AddMember rcEmpfaenger 'Den Recipient der Liste hinzufgen
                End If
                'nun das gleiche fr die zweite MAiladresse
                Set rcEmpfaenger = Outlook.Session.CreateRecipient(itsKontakte(j).Email2Address)
                If rcEmpfaenger.Resolve = True Then
                    'sollte die MAiladresse leer sein, dann ergibt die resolve Methode einen Fehler und es wird auch
                    'kein Empfnger hinzugefgt ...
                    dlVerteilerliste.AddMember rcEmpfaenger
                End If
            End If
        Next
        If bolErfolg = True Then 'wenn mindestens eine Mailadresse vorhanden war und deshalb also ein Empfnger eingteragen wurde
            dlVerteilerliste.Save 'die Liste nun auch speichern
            
            'ich lasse das Skript an dieser Stelle noch eine Mail an die neue Verteielrliste erstellen. Dadurch wird der Name der Liste auch
            'in die Vorschlagsliste fr Autovervollstndigung aufgenommen - also die Vorschlge, die man beim Tippen der Empngeradresse bekommt.
            Set objMail = Application.CreateItem(olMailItem)
            With objMail
                .Recipients.Add ("_" & colKategorien(i) & " _")
                .Recipients.ResolveAll
                'fr diese Resolve Methode ist es gut, dass die Liste durch ddie Unterstriche einen eindeutigen Namen hat, damit es nicht mehrere
                'Mglichkeiten gibt (ich nutze nmlich "aufbauende" Kategorien - z.B.: 1) "Stammtisch" 2) "Stammtisch | Mitglieder" 3) "Stammtisch | Vorstand" 4) "Stammtisch | Vorsatand | Vorsitzender"
                'Wrde ich ohne eindeutige Zeichen arbeiten, dann wrde die ResolveMethode fehlschlagen
                
                'Der Unterstrich am Anfang wre dazu eigentlich nicht ntig - aber der hat einen anderen Vorteil. Tippe ich in die Adresszeile
                'nur einen Unterstrich, dann werden bereits alle Listen angezeigt und so kann man ggfs auch durch die Kategorien scrollen
                
                'Das klappt nun also und so kann ich die dafr erstellte Mail wieder lschen...
                .Delete
            End With

        Else
            dlVerteilerliste.Delete 'falls keine Kontakte in der Kategorie vorhanden, die Liste wieder lschen, da die Liste leer wre...
        End If
  End If
  bolErfolg = False 'Reset fr nchsten Durchlauf
Next

End Sub



'wird zum Sortieren der Kategorien bentigt - habe ich aus dem Netzt "geraubt"
Function CollectionSort(ByRef oCollection As Collection, Optional bSortAscending As Boolean = True) As Long
    Dim lSort1 As Long, lSort2 As Long
    Dim vTempItem1 As Variant, vTempItem2 As Variant, bSwap As Boolean
    
    On Error GoTo ErrFailed
    For lSort1 = 1 To oCollection.Count - 1
        For lSort2 = lSort1 + 1 To oCollection.Count
            If bSortAscending Then
                If oCollection(lSort1) > oCollection(lSort2) Then
                    bSwap = True
                Else
                    bSwap = False
                End If
            Else
                If oCollection(lSort1) < oCollection(lSort2) Then
                    bSwap = True
                Else
                    bSwap = False
                End If
            End If
            If bSwap Then
                'Store the items
                If VarType(oCollection(lSort1)) = vbObject Then
                    Set vTempItem1 = oCollection(lSort1)
                Else
                    vTempItem1 = oCollection(lSort1)
                End If
                
                If VarType(oCollection(lSort2)) = vbObject Then
                    Set vTempItem2 = oCollection(lSort2)
                Else
                    vTempItem2 = oCollection(lSort2)
                End If
                
                'Swap the items over
                oCollection.Add vTempItem1, , lSort2
                oCollection.Add vTempItem2, , lSort1
                'Delete the original items
                oCollection.Remove lSort1 + 1
                oCollection.Remove lSort2 + 1
            End If
        Next
    Next
    Exit Function
    
ErrFailed:
    Debug.Print "Error with CollectionSort: " & Err.Description
    CollectionSort = Err.Number
    On Error GoTo 0
End Function



